unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, GLScene, GLObjects, GLCoordinates,
  GLCrossPlatform, BaseClasses, GLWin32Viewer, GLShadowPlane, AsyncTimer,
  GLPolyhedron;

type
  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLSphere1: TGLSphere;
    GLDummyCube1: TGLDummyCube;
    GLPlane1: TGLPlane;
    GLShadowPlane1: TGLShadowPlane;
    AsyncTimer1: TAsyncTimer;
    GLTetrahedron1: TGLTetrahedron;
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AsyncTimer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    xa,ya : integer;
    t     : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  t := 0;
end;

procedure TForm1.AsyncTimer1Timer(Sender: TObject);
var
  r : single;
begin
  r := cos(Pi*t/10);
  GLLightSource1.Position.X := r;
  GLLightSource1.Position.Y := r;
  t := t + 1;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  xa := X;
  ya := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if (ssLeft in Shift) then begin
    GLCamera1.MoveAroundTarget(Y-ya,X-xa);
    xa := X; ya := Y;
  end;
end;

end.
